Subject: Re: bug#50067: Context menus

From: Juri Linkov <[email-masked]>
Date: Fri, 20 Aug 2021 10:29:47 +0300

>> GUI toolkits can't ignore titles for all menus.  Some menus should be
>> displayed with a title for all toolkits.
>
> Which popup menus have titles that cannot be ignored, and why?

An example of such menu is mouse-buffer-menu bound to C-<down-mouse-1>
where the user might wonder what do these menu items with mode names mean?

>> The context menu is special.  Nowadays everyone is accustomed to
>> down-mouse-3 popping up a context menu without title.  But other
>> Emacs-specific menus that are not familiar to users such as
>> mouse-buffer-menu bound C-<down-mouse-1> should display a title for
>> all toolkits to explain to the user what choice the menu presents.
>
> If we want some titles to behave in special ways, we could put a text
> property on the title string to mark those titles that should get
> special treatment.  That is better than removing the title, and
> certainly better than removing it based on the frame type, because
> then Lisp code which handles the menu keymaps will need to be prepared
> to handle both kinds of menu keymaps, the ones with a title and ones
> without it.  It is also against the documented practice.

Using a text property would be a good solution.  Should then
the NS-specific "Select" title be removed in menu.c
when the title has a special text property?